-- name: Hangout - Final Fantasy 7 - Gaia Overworld
-- description: The last game world that should touch a game with "64" in it's name. \n\nMap rip from The Models Resource. \n\nMap port done by Buckley Tim.

local audioToPlay = audio_stream_load("FF7main_mario.ogg")


-- use fixed collisions
gLevelValues.fixCollisionBugs = 1

-- register level
LEVEL_HANGOUT_GAIA_EAST = 77
level_register('level_gaia_east_entry', COURSE_NONE, "Gaia_east", 'gaia_east', 28000, 0x28, 0x28, 0x28)
local level_hangout_gaia_east = smlua_level_util_get_info_from_short_name('gaia_east')
level_hangout_gaia_east.levelNum = LEVEL_HANGOUT_GAIA_EAST

-- register level
LEVEL_HANGOUT_GAIA_WEST = 78
level_register('level_gaia_west_entry', COURSE_NONE, "Gaia_west", 'gaia_west', 28000, 0x28, 0x28, 0x28)
local level_hangout_gaia_west = smlua_level_util_get_info_from_short_name('gaia_west')
level_hangout_gaia_west.levelNum = LEVEL_HANGOUT_GAIA_WEST

-- register level
LEVEL_HANGOUT_GAIA_NORTH = 79
level_register('level_gaia_north_entry', COURSE_NONE, "Gaia_north", 'gaia_north', 28000, 0x28, 0x28, 0x28)
local level_hangout_gaia_north = smlua_level_util_get_info_from_short_name('gaia_north')
level_hangout_gaia_north.levelNum = LEVEL_HANGOUT_GAIA_NORTH

function notifynewplayers()
    djui_chat_message_create("Final Fantasy 7 - Gaia maps are available as hangouts.")
end

function ff7_east_warp()
    if gNetworkPlayers[0] then
        warp_to_level(LEVEL_HANGOUT_GAIA_EAST, 1, 0)
        return true
    end
end

function ff7_west_warp()
    if gNetworkPlayers[0] then
        warp_to_level(LEVEL_HANGOUT_GAIA_WEST, 1, 0)
        return true
    end
end

function ff7_north_warp()
    if gNetworkPlayers[0] then
        warp_to_level(LEVEL_HANGOUT_GAIA_NORTH, 1, 0)
        return true
    end
end

hook_event(HOOK_JOINED_GAME, notifynewplayers)
hook_chat_command("ff7-east", "Warps you to Gaia - East Continent", ff7_east_warp)
hook_chat_command("ff7-west", "Warps you to Gaia - West Continent", ff7_west_warp)
hook_chat_command("ff7-north", "Warps you to Gaia - North Continent", ff7_north_warp)

-----
--audio stuff
-----

function on_warp()

    --debug that gives me level id on warp when enabled
    --djui_popup_create(gNetworkPlayers[0].currLevelNum .. "", 2)

    if gNetworkPlayers[0].currLevelNum == 77 or gNetworkPlayers[0].currLevelNum == 78 or gNetworkPlayers[0].currLevelNum == 79 then
        stop_background_music(get_current_background_music())
        audio_stream_stop(audioToPlay)

        audio_stream_destroy(audioToPlay)
        audioToPlay = audio_stream_load("FF7main_mario.ogg")
        audio_stream_set_looping(audioToPlay, true)
        audio_stream_play(audioToPlay, true, 1)
    else
        audio_stream_stop(audioToPlay)

    end
end

-- disable cap music
-- this code taken from the arena dx mod
function music()
    local np = gNetworkPlayers[0]
    if np.currLevelNum == 77 or np.currLevelNum == 78 or np.currLevelNum == 79 then
        stop_cap_music()
    end
end

hook_event(HOOK_UPDATE, music)
hook_event(HOOK_ON_WARP, on_warp)
